<template>
    <div>
      <div class="main">
      <h1> <img src=".././assets/cadastro.jpg" alt="cadastro" style="width: 100px"> <b>Cadastro de Viagem</b> </h1>
      <br>

        <ul>
          <li v-for="(erro, index) of errors" :key="index">
            campo <b> {{ erro.field }} </b> - {{ erro.defaultMessage }}
          </li>
        </ul>

      <form @submit.prevent="salvar">

        <div class="form-row">
          <div class="form-group col-md-6">
            <label for="inputDistancia4">Distância Pré Origem</label>
            <input type="number" step="0.0005" class="form-control" id="inputDistancia4" placeholder="Distancia pré origem" v-model="viagem.dist_pre">
          </div>
          <div class="form-group col-md-6">
            <label for="inputOrigem4">Distância Origem-Destino</label>
            <input type="number" step="0.0005" class="form-control" id="inputOrigem4" placeholder="Distancia Origem-Destino" maxlength="11" v-model="viagem.dist_real">
          </div>
          <!-- <div class="form-group col-md-4">
              <label for="inputPassageiro">Passageiros</label>
              <input type="text" class="form-control" id="inputPassageiro" >
            </div> -->
        </div>
        <div class="form-row">
          <div class="form-group col-md-4">
            <label for="inputCityOrigem">Origem</label>
            <input type="text" class="form-control" id="inputCityOrigem" v-model="viagem.origem">
          </div>
          <div class="form-group col-md-2">
            <label for="inputParadasOrigem">Paradas Origem</label>
            <input type="number" class="form-control" id="inputParadasOrigem" v-model="viagem.origem_estado">
          </div>
          <div class="form-group col-md-4">
              <label for="inputCityDestino">Destino</label>
              <input type="text" class="form-control" id="inputCityDestino" v-model="viagem.destino">
          </div>
          <div class="form-group col-md-2">
              <label for="inputParadasDestino">Paradas Destino</label>
              <input type="number" class="form-control" id="inputParadasDestino" v-model="viagem.destino_estado">
            </div>
            </div>
        <div class="form-row">
            <div class="form-group col-md-4">
                <label for="inputOrcamento">Orçamento</label>
                <input type="number" step="0.0005" class="form-control" id="inputOrcamento"  maxlength="11" v-model="viagem.orcamento">
            </div>
          <div class="form-group col-md-3">
            <label for="inputDataSaida">Data de Saída</label>
            <input type="date" id="inputDataSaida" class="form-control" v-model="viagem.data_s">
          </div>
          <div class="form-group col-md-3">
            <label for="inputDataRetorno">Data de Retorno</label>
            <input type="date" class="form-control" id="inputDataRetorno" v-model="viagem.data_r">
          </div>
          <div class='form-group col-md-2'>
            <label for="inputHorarioSaida">Horário de Saída</label>
            <input type="text" class="form-control" id="inputHorarioSaida" maxlength="15" v-model="viagem.hora_s">
          </div>
        </div>
        <button class="btn btn-primary">Enviar</button>
      </form>
      <div style='margin: 2%'>
        <h1> Viagens  </h1>
        <!-- <router-link to='/motorista_add'>
            <button type="button" class="btn btn-primary">Cadastrar</button>
        </router-link> -->
        </div>
        
    <table class="table">
        <thead class="bg-success">
          <tr>
            <th>ID</th>
            <th>Destino</th>
            <th>Origem</th>
            <th>Data de Saída</th>
            <th>Data de Retorno</th>
            <th>Horário de Saída</th>
            <th>Ações</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="viagem of viagens" :key="viagem.id">
            <td>{{ viagem.id }}</td>
            <td>{{ viagem.origem }}</td>
            <td>{{ viagem.destino }}</td>
            <td>{{ viagem.data_s }}</td>
            <td>{{ viagem.data_r }}</td>
            <td>{{ viagem.hora_s }}</td>
            <td id="botao"> 
              <router-link v-bind:to="'/viagem_add_motorista/' + viagem.id"><button type="button" id="botao" class="btn btn-primary">Motoristas</button></router-link>
              <button type="button" @click="editar(viagem)" id="botao" class="btn btn-info" style="margin-left: 2%">Editar</button><br>
              <router-link v-bind:to="'/viagem_add_passageiros/' + viagem.id"><button type="button" id="botao" class="btn btn-warning">Passageiros</button></router-link>
              <button type="button" @click="remover(viagem)" id="botao" class="btn btn-danger">Deletar</button> 
            </td>
            </tr>
        </tbody>
    </table>
    </div>
    </div>
</template>
<script>
  import Viagem from '../services/viagens'
  import axios from 'axios'
  import { httpGet } from '../services/config'

  export default {
    
    data(){
      return{
        viagem: {
          id: '',
          dist_pre: '',
          dist_real: '',
          origem: '',
          origem_estado: '',
          destino: '',
          destino_estado: '',
          orcamento: '',
          data_s: '',
          hora_s: '',
          data_r: ''
        },
        viagens: [],
        errors: [],
        
      }
    },

    mounted (){
        this.listar()
    },

    methods:{

      listar(){
        Viagem.listar().then(resposta => {
        this.viagens = resposta.data
        console.log(resposta.data)
        })
      },

      salvar(){
        if(!this.viagem.id) {
        Viagem.salvar(this.viagem).then(resposta => {
          this.viagem = {}
          alert('Viagem Salva com Sucesso!')
          this.listar()
          this.errors = []
        }).catch(e =>{
            this.errors = e.response.data.errors
        })
        }else {
                Viagem.atualizar(this.viagem).then(resposta => {
                    this.viagem = {}
                    alert('Viagem Atualizada!')
                    this.errors = []
                    this.listar()
                }).catch(e => {
                    this.errors = e.response.data.errors
                })
            }
      },

      editar(viagem){
        this.viagem = viagem
      },

      remover(viagem) {

            if (confirm('Deseja cancelar a viagem?')) {
                axios.delete(httpGet() + '/viagens/' + viagem.id).then(resposta => {
                    this.errors = []
                    this.listar()
                }).catch(e => {
                    this.erros = e.response.data.errors
                })
            }
      },

    }

  }
</script>

<style>

   h1 {
      text-align: center;
   }

   #botao {
     margin: 2px;
     text-align: center;
   }

</style>
